#ifndef IRSSI_GJS_FUNCTIONS_XS_MACROS_H_
#define IRSSI_GJS_FUNCTIONS_XS_MACROS_H_

#define SF_VARS(args)					\
  nSCX; nRV; nArgv;							\
  SF_AT a[sizeof(args)] = { { 0 } };					\
  const char *fmt = args
#define SFV_VARS(args, nklass)						\
  nSCX; nRV; nArgv;							\
  nklass *N;								\
  SF_AT a[sizeof(args)] = { { 0 } };					\
  const char *fmt = args

#define SF0_VARS	nSCX	 __attribute__((__unused__)); nRV
#define BEGIN		{JS_BeginRequest(cx)
#define END		\
  rv = JS_TRUE;					\
SCX_cleanup:					\
 JS_EndRequest(cx);}				\
 return rv;

#define ARGS(spec...)					\
  if (!JS_ConvertArguments(cx, argc, argv, spec)) {	\
    char			*fun_name;	\
    JSString *jfun_name =			\
      JS_GetFunctionDisplayId(JS_ValueToFunction(cx, JS_CALLEE(cx, vp)));	\
    fun_name		= JS_EncodeString(cx, jfun_name);	\
    JS_ReportError(cx, "%s: argument mismatch", fun_name);	\
    JS_free(cx, fun_name);			\
    goto SCX_cleanup;				\
  }

#define BEGIN0		{JS_BeginRequest(cx)
#define END0		\
  rv = JS_TRUE;					\
 JS_EndRequest(cx);}				\
 return rv;

#define RV(rv)		JS_SET_RVAL(cx, vp, rv)

typedef union {
  JSBool	 b;
  int32_t	 i;
  char		*s;
  JSString	*js;
  JSObject      *o;
} SF_AT;


#define B_TOBJ(klass)	JS_RVAL(cx,vp) = OBJECT_TO_JSVAL(gjs_irssi_c_bless_object(cx, #klass,
#define E_TOBJ(x)	))
#define B_VOID		JS_RVAL(cx,vp) = JSVAL_VOID ;
#define E_VOID
#define	B_XSTR {				\
  char	*ret;					\
  ret =	
#define	E_XSTR		;				\
  JS_RVAL(cx, vp) = safe_make_js_string(cx, ret);	\
  g_free(ret);						\
  }
#define B_STR			JS_RVAL(cx,vp) = safe_make_js_string(cx,
#define E_STR			)
#define B_INT			JS_RVAL(cx,vp) = INT_TO_JSVAL(
#define E_INT			)
#define B_IOBJ			B_TOBJ(iobject)
#define E_IOBJ			E_TOBJ(iobject)
#define B_SIOBJ			B_TOBJ(siobject)
#define E_SIOBJ			E_TOBJ(siobject)
#define B_BOOL			JS_RVAL(cx,vp) = BOOLEAN_TO_JSVAL(
#define E_BOOL			)
#define B_TOBJARR(klass)	{			\
    GSList   *tmp;				\
    JSObject *ret;				\
    uint32_t  i = 0;					\
    ret = JS_NewArrayObject(cx, 0, NULL);		\
    for (tmp = 
#define		 E_TOBJARR(klass)	; tmp != NULL; tmp = tmp->next) {	\
      jsval r;								\
      r = OBJECT_TO_JSVAL(gjs_irssi_c_bless_object(cx, #klass, tmp->data));	\
      JS_SetElement(cx, ret, i++, &r);					\
    }									\
    JS_RVAL(cx,vp) = OBJECT_TO_JSVAL(ret);				\
  }
#define B_IOBJARR	B_TOBJARR(iobject)
#define E_IOBJARR	E_TOBJARR(iobject)
#define B_SIOBJARR	B_TOBJARR(siobject)
#define E_SIOBJARR	E_TOBJARR(siobject)
#define B_STRARR	{			\
    GSList   *tmp;				\
    JSObject *ret;				\
    uint32_t  i = 0;					\
    ret = JS_NewArrayObject(cx, 0, NULL);		\
    for (tmp = 
#define		 E_STRARR	; tmp != NULL; tmp = tmp->next) {	\
      jsval r;								\
      r = safe_make_js_string(cx, tmp->data);	\
      JS_SetElement(cx, ret, i++, &r);					\
    }									\
    JS_RVAL(cx,vp) = OBJECT_TO_JSVAL(ret);				\
  }

#define SFG_ARGS_PRE	\
  {									\
    unsigned cnt, idx = 0;						\
    for (cnt = 0; fmt[cnt]; ++cnt) {					\
      switch (fmt[cnt]) {						\
      case 'S':								\
	a[idx].s    = decode_js_string(cx, a[idx].js);			\
									\
	break;								\
      }									\
      switch (fmt[cnt]) {						\
      case '/':								\
      case '.':								\
	break;								\
      default:								\
	++idx;								\
      }									\
    }									\
  }

#define SFG_ARGS_POST	\
  {									\
    unsigned cnt, idx = 0;						\
    for (cnt = 0; fmt[cnt]; ++cnt) {					\
      switch (fmt[cnt]) {						\
      case 'S':								\
	g_free(a[idx].s);						\
									\
	break;								\
      }									\
      switch (fmt[cnt]) {						\
      case '/':								\
      case '.':								\
	break;								\
      default:								\
	++idx;								\
      }									\
    }									\
  }

#define SFG_CALL_ARGS						\
    if (fmt[0]) {							\
      ARGS(fmt, &a[0], &a[1], &a[2], &a[3], &a[4], &a[5]);		\
    }

#define SF_BEGIN \
  BEGIN;								\
  SFG_CALL_ARGS;							\
  get_cSCX;								\
  SFG_ARGS_PRE;								\

#define SF_END 					\
  SFG_ARGS_POST;				\
  END

#define SF_GEN(fun, args, cv, impl)		\
  SCRIPT_FUN(fun) {				\
    SF_VARS(args);							\
    SF_BEGIN;								\
    B_ ## cv impl E_ ## cv ;						\
    SF_END;								\
  }

#define BEGIN_V(klass) \
  BEGIN;				\
  CHECK_V(N, JS_THIS_VALUE(cx, vp), klass)

#define SV_BEGIN(klass)				\
  BEGIN_V(klass);				\
  SFG_CALL_ARGS;				\
  get_cSCX;					\
  SFG_ARGS_PRE

#define SV_END SF_END

#define SV_GEN(klass, name, nklass, args, cv, impl)	\
  SCRIPT_FUN(klass ## _ ## name) {			\
    SFV_VARS(args, nklass);						\
    SV_BEGIN(klass);							\
    B_ ## cv impl E_ ## cv ;						\
    SV_END;								\
  }


#define CHECK_V(dest, val, klass) { 					\
    JSBool ret = JS_FALSE;						\
    if (!JS_HasInstance(cx, gjs_ ## klass ## _cto, val, &ret))		\
      goto SCX_cleanup;							\
    if (!ret) {								\
      JS_ReportError(cx, "Object of wrong class");			\
      goto SCX_cleanup;							\
    }									\
    if (!(dest = JS_GetPrivate(JSVAL_TO_OBJECT(val)))) {		\
      JS_ReportError(cx, "can't access dead object");			\
      goto SCX_cleanup;							\
    }									\
  }
#define ALLOW_NULL_N(dest, var, klass) 	\
  if (!var) dest = NULL;						\
  else {								\
    CHECK_V(dest, OBJECT_TO_JSVAL(var), klass);				\
  }
#define CHECK_VN(dest, var, klass) 	\
  CHECK_V(dest, OBJECT_TO_JSVAL(var), klass)	\


#endif
