#ifndef IRSSI_GJS_FUNCTIONS_H_
#define IRSSI_GJS_FUNCTIONS_H_

#include "console.h"
#include "xs-macros.h"

void
script_settings_add_str(const char *s1, const char *s2, const char *s3);
void
script_settings_add_int(const char *s1, const char *s2, int i3);
void
script_settings_add_bool(const char *s1, const char *s2, int i3);
void
script_settings_add_time(const char *s1, const char *s2, const char *s3);
void
script_settings_add_level(const char *s1, const char *s2, const char *s3);
void
script_settings_add_size(const char *s1, const char *s2, const char *s3);
void
script_settings_remove(const char *s1);

SCRIPT_FUN(core_print);
SCRIPT_FUN(irssi_print);
SCRIPT_FUN(irssi_abstracts_register); /* SVptr $abstracts */
SCRIPT_FUN(irssi_active_server);
SCRIPT_FUN(irssi_active_win);
SCRIPT_FUN(irssi_bits2level); /* int $bits */
SCRIPT_FUN(irssi_channel_find); /* string $channel */
SCRIPT_FUN(irssi_channels);
SCRIPT_FUN(irssi_chatnet_find); /* string $name */
SCRIPT_FUN(irssi_chatnets);
SCRIPT_FUN(irssi_combine_level); /* int $level, string $str */
SCRIPT_FUN(irssi_command); /* string $cmd */
SCRIPT_FUN(irssi_command_bind); /* ... XXX */
SCRIPT_FUN(irssi_command_bind_first); /* ... XXX */
SCRIPT_FUN(irssi_command_bind_last); /* ... XXX */
SCRIPT_FUN(irssi_command_parse_options); /* string $cmd, string $data */
SCRIPT_FUN(irssi_command_runsub); /* string $cmd, string $data, Irssi::Server $server, Irssi::Windowitem $item */
SCRIPT_FUN(irssi_command_set_options); /* string $cmd, string $options */
SCRIPT_FUN(irssi_command_unbind); /* string $cmd, SVptr $func */
SCRIPT_FUN(irssi_commands);
SCRIPT_FUN(irssi_ctcp_register); /* string $name */
SCRIPT_FUN(irssi_ctcp_unregister); /* string $name */
SCRIPT_FUN(irssi_current_theme);
  /* FUN_DEF(irssi, deinit, 0), */
SCRIPT_FUN(irssi_expando_create); /* string $key, SVptr $func, SVptr $signals */
SCRIPT_FUN(irssi_expando_destroy); /* string $name */
SCRIPT_FUN(irssi_format_create_dest); /* string $target, int $level, Irssi::UI::Window $window */
SCRIPT_FUN(irssi_format_get_length); /* string $str */
SCRIPT_FUN(irssi_format_real_length); /* string $str, int $len */
SCRIPT_FUN(irssi_get_gui);
SCRIPT_FUN(irssi_get_irssi_binary);
SCRIPT_FUN(irssi_get_irssi_config);
SCRIPT_FUN(irssi_get_irssi_dir);
SCRIPT_FUN(irssi_gui_input_get_pos);
SCRIPT_FUN(irssi_gui_input_set); /* string $str */
SCRIPT_FUN(irssi_gui_input_set_pos); /* int $pos */
SCRIPT_FUN(irssi_gui_printtext); /* int $xpos, int $ypos, string $str */
SCRIPT_FUN(irssi_ignore_check); /* string $nick, string $host, string $channel, string $text, int $level */
SCRIPT_FUN(irssi_ignores);
  /* FUN_DEF(irssi, init, 0), */
SCRIPT_FUN(irssi_input_add); /* int $source, int $condition, SVptr $func, SVptr $data */
SCRIPT_FUN(irssi_input_remove); /* int $tag */
SCRIPT_FUN(irssi_level2bits); /* string $str */
SCRIPT_FUN(irssi_log_create_rec); /* string $fname, int $level */
SCRIPT_FUN(irssi_log_find); /* string $fname */
SCRIPT_FUN(irssi_logs);
SCRIPT_FUN(irssi_mask_match); /* string $mask, string $nick, string $user, string $host */
SCRIPT_FUN(irssi_mask_match_address); /* string $mask, string $nick, string $address */
SCRIPT_FUN(irssi_masks_match); /* string $masks, string $nick, string $address */
SCRIPT_FUN(irssi_parse_special); /* string $cmd, string $data, int $flags */
SCRIPT_FUN(irssi_pidwait_add); /* int $pid */
SCRIPT_FUN(irssi_pidwait_remove); /* int $pid */
SCRIPT_FUN(irssi_print); /* string $str, int $level */
SCRIPT_FUN(irssi_printformat); /* int $level, string $format, ... */
SCRIPT_FUN(irssi_queries);
SCRIPT_FUN(irssi_query_find); /* string $nick */
SCRIPT_FUN(irssi_rawlog_create);
SCRIPT_FUN(irssi_rawlog_set_size); /* int $lines */
SCRIPT_FUN(irssi_reconnects);
SCRIPT_FUN(irssi_server_create_conn); /* int $chat_type, string $dest, int $port, string $chatnet, string $password, string $nick */
SCRIPT_FUN(irssi_server_find_chatnet); /* string $chatnet */
SCRIPT_FUN(irssi_server_find_tag); /* string $tag */
SCRIPT_FUN(irssi_servers);
SCRIPT_FUN(irssi_settings_add_bool); /* string $section, string $key, int $def */
SCRIPT_FUN(irssi_settings_add_int); /* string $section, string $key, int $def */
SCRIPT_FUN(irssi_settings_add_level); /* string $section, string $key, string $def */
SCRIPT_FUN(irssi_settings_add_size); /* string $section, string $key, string $def */
SCRIPT_FUN(irssi_settings_add_str); /* string $section, string $key, string $def */
SCRIPT_FUN(irssi_settings_add_time); /* string $section, string $key, string $def */
SCRIPT_FUN(irssi_settings_get_bool); /* string $key */
SCRIPT_FUN(irssi_settings_get_int); /* string $key */
SCRIPT_FUN(irssi_settings_get_level); /* string $key */
SCRIPT_FUN(irssi_settings_get_size); /* string $key */
SCRIPT_FUN(irssi_settings_get_str); /* string $key */
SCRIPT_FUN(irssi_settings_get_time); /* string $key */
SCRIPT_FUN(irssi_settings_remove); /* string $key */
SCRIPT_FUN(irssi_settings_set_bool); /* string $key, int $value */
SCRIPT_FUN(irssi_settings_set_int); /* string $key, int $value */
SCRIPT_FUN(irssi_settings_set_level); /* string $key, string $value */
SCRIPT_FUN(irssi_settings_set_size); /* string $key, string $value */
SCRIPT_FUN(irssi_settings_set_str); /* string $key, string $value */
SCRIPT_FUN(irssi_settings_set_time); /* string $key, string $value */
SCRIPT_FUN(irssi_signal_add); /* ... XXX */
SCRIPT_FUN(irssi_signal_add_first); /* ... XXX */
SCRIPT_FUN(irssi_signal_add_last); /* ... XXX */
SCRIPT_FUN(irssi_signal_add_priority); /* ... XXX */
SCRIPT_FUN(irssi_signal_continue); /* ... XXX */
SCRIPT_FUN(irssi_signal_emit); /* string $signal, ... */
SCRIPT_FUN(irssi_signal_get_emitted);
SCRIPT_FUN(irssi_signal_get_emitted_id);
SCRIPT_FUN(irssi_signal_register); /* ... XXX */
SCRIPT_FUN(irssi_signal_remove); /* string $signal, SVptr $func */
SCRIPT_FUN(irssi_signal_stop);
SCRIPT_FUN(irssi_signal_stop_by_name); /* string $signal */
SCRIPT_FUN(irssi_statusbar_item_register); /* string $name, string $value, string $func */
SCRIPT_FUN(irssi_statusbar_item_unregister); /* string $name */
SCRIPT_FUN(irssi_statusbar_items_redraw); /* string $name */
SCRIPT_FUN(irssi_statusbars_recreate_items);
SCRIPT_FUN(irssi_strip_codes); /* string $input */
SCRIPT_FUN(irssi_theme_register); /* SVptr $formats */
SCRIPT_FUN(irssi_themes_reload);
SCRIPT_FUN(irssi_timeout_add); /* int $msecs, SVptr $func, SVptr $data */
SCRIPT_FUN(irssi_timeout_add_once); /* int $msecs, SVptr $func, SVptr $data */
SCRIPT_FUN(irssi_timeout_remove); /* int $tag */
SCRIPT_FUN(irssi_version);
SCRIPT_FUN(irssi_window_find_closest); /* string $name, int $level */
SCRIPT_FUN(irssi_window_find_item); /* string $name */
SCRIPT_FUN(irssi_window_find_level); /* int $level */
SCRIPT_FUN(irssi_window_find_name); /* string $name */
SCRIPT_FUN(irssi_window_find_refnum); /* int $refnum */
SCRIPT_FUN(irssi_window_item_find); /* string $name */
SCRIPT_FUN(irssi_window_refnum_next); /* int $refnum, int $wrap */
SCRIPT_FUN(irssi_window_refnum_prev); /* int $refnum, int $wrap */
SCRIPT_FUN(irssi_windows);
SCRIPT_FUN(irssi_windows_refnum_last);

SCRIPT_FUN(irssi_ui_window_format_create_dest);
SCRIPT_FUN(irssi_ui_window_activity);
SCRIPT_FUN(irssi_ui_window_change_server);
SCRIPT_FUN(irssi_ui_window_command);
SCRIPT_FUN(irssi_ui_window_destroy);
SCRIPT_FUN(irssi_ui_window_format_get_text);
SCRIPT_FUN(irssi_ui_window_get_active_name);
SCRIPT_FUN(irssi_ui_window_get_history_lines);
SCRIPT_FUN(irssi_ui_window_gui_printtext_after);
SCRIPT_FUN(irssi_ui_window_item_add);
SCRIPT_FUN(irssi_ui_window_item_destroy);
SCRIPT_FUN(irssi_ui_window_item_find);
SCRIPT_FUN(irssi_ui_window_item_next);
SCRIPT_FUN(irssi_ui_window_item_prev);
SCRIPT_FUN(irssi_ui_window_item_remove);
SCRIPT_FUN(irssi_ui_window_items);
SCRIPT_FUN(irssi_ui_window_last_line_insert);
SCRIPT_FUN(irssi_ui_window_print);
SCRIPT_FUN(irssi_ui_window_print_after);
SCRIPT_FUN(irssi_ui_window_printformat);
SCRIPT_FUN(irssi_ui_window_set_active);
SCRIPT_FUN(irssi_ui_window_set_history);
SCRIPT_FUN(irssi_ui_window_set_level);
SCRIPT_FUN(irssi_ui_window_set_name);
SCRIPT_FUN(irssi_ui_window_set_refnum);
SCRIPT_FUN(irssi_ui_window_view);

SCRIPT_FUN(irssi_server_channel_find);
SCRIPT_FUN(irssi_server_channels);
SCRIPT_FUN(irssi_server_channels_join);
SCRIPT_FUN(irssi_server_command);
SCRIPT_FUN(irssi_server_disconnect);
SCRIPT_FUN(irssi_server_format_create_dest);
SCRIPT_FUN(irssi_server_get_nick_flags);
SCRIPT_FUN(irssi_server_ignore_check);
SCRIPT_FUN(irssi_server_ischannel);
SCRIPT_FUN(irssi_server_isnickflag);
SCRIPT_FUN(irssi_server_mask_match);
SCRIPT_FUN(irssi_server_mask_match_address);
SCRIPT_FUN(irssi_server_masks_match);
SCRIPT_FUN(irssi_server_nicks_get_same);
SCRIPT_FUN(irssi_server_parse_special);
SCRIPT_FUN(irssi_server_print);
SCRIPT_FUN(irssi_server_printformat);
SCRIPT_FUN(irssi_server_queries);
SCRIPT_FUN(irssi_server_query_find);
/* SCRIPT_FUN(irssi_server_ref) */ /* Irssi::Server $server */
SCRIPT_FUN(irssi_server_send_message);
/* SCRIPT_FUN(irssi_server_unref) */ /* Irssi::Server $server */
SCRIPT_FUN(irssi_server_window_find_closest);
SCRIPT_FUN(irssi_server_window_find_item);
SCRIPT_FUN(irssi_server_window_find_level);
SCRIPT_FUN(irssi_server_window_item_find);
SCRIPT_FUN(irssi_server_gui_printtext_after);


SCRIPT_FUN(irssi_windowitem_activity);
SCRIPT_FUN(irssi_windowitem_change_server);
SCRIPT_FUN(irssi_windowitem_command);
SCRIPT_FUN(irssi_windowitem_get_dcc);
SCRIPT_FUN(irssi_windowitem_is_active);
SCRIPT_FUN(irssi_windowitem_parse_special);
SCRIPT_FUN(irssi_windowitem_print);
SCRIPT_FUN(irssi_windowitem_printformat);
SCRIPT_FUN(irssi_windowitem_set_active);
SCRIPT_FUN(irssi_windowitem_window);
SCRIPT_FUN(irssi_windowitem_window_create);


SCRIPT_FUN(irssi_channel_destroy);
SCRIPT_FUN(irssi_channel_nick_find);
SCRIPT_FUN(irssi_channel_nick_find_mask);
SCRIPT_FUN(irssi_channel_nick_insert);
SCRIPT_FUN(irssi_channel_nick_remove);
SCRIPT_FUN(irssi_channel_nicks);

SCRIPT_FUN(irssi_query_change_server);
SCRIPT_FUN(irssi_query_destroy);


SCRIPT_FUN(irssi_ui_textdest_print);

SCRIPT_FUN(irssi_log_close); /* Irssi::Log $log */
SCRIPT_FUN(irssi_log_item_add); /* Irssi::Log $log, int $type, string $name, string $servertag */
SCRIPT_FUN(irssi_log_item_destroy); /* Irssi::Log $log, Irssi::Logitem $item */
SCRIPT_FUN(irssi_log_item_find); /* Irssi::Log $log, int $type, string $item, string $servertag */
SCRIPT_FUN(irssi_log_start_logging); /* Irssi::Log $log */
SCRIPT_FUN(irssi_log_stop_logging); /* Irssi::Log $log */
SCRIPT_FUN(irssi_log_update); /* Irssi::Log $log */
SCRIPT_FUN(irssi_log_write_rec); /* Irssi::Log $log, string $str, int $level */

SCRIPT_FUN(irssi_rawlog_close);
SCRIPT_FUN(irssi_rawlog_destroy);
SCRIPT_FUN(irssi_rawlog_get_lines);
SCRIPT_FUN(irssi_rawlog_input);
SCRIPT_FUN(irssi_rawlog_open);
SCRIPT_FUN(irssi_rawlog_output);
SCRIPT_FUN(irssi_rawlog_redirect);
SCRIPT_FUN(irssi_rawlog_save);

SCRIPT_FUN(irssi_textui_line_get_text);
SCRIPT_FUN(irssi_textui_line_next);
SCRIPT_FUN(irssi_textui_line_prev);


SCRIPT_FUN(irssi_textui_textbufferview_clear);
SCRIPT_FUN(irssi_textui_textbufferview_get_bookmark);
SCRIPT_FUN(irssi_textui_textbufferview_get_lines);
SCRIPT_FUN(irssi_textui_textbufferview_redraw);
SCRIPT_FUN(irssi_textui_textbufferview_remove_all_lines);
SCRIPT_FUN(irssi_textui_textbufferview_scroll);
SCRIPT_FUN(irssi_textui_textbufferview_set_bookmark_bottom);
SCRIPT_FUN(irssi_textui_textbufferview_set_default_indent);
SCRIPT_FUN(irssi_textui_textbufferview_set_scroll);
SCRIPT_FUN(irssi_textui_textbufferview_remove_line);
SCRIPT_FUN(irssi_textui_textbufferview_set_bookmark);
SCRIPT_FUN(irssi_textui_textbufferview_get_line_cache);
SCRIPT_FUN(irssi_textui_textbufferview_scroll_line);

SCRIPT_FUN(irssi_textui_statusbaritem_default_handler);

SCRIPT_FUN(irssi_ui_theme_format_expand);
SCRIPT_FUN(irssi_ui_theme_get_format);

SCRIPT_FUN(irssi_ui_processes);
SCRIPT_FUN(irssi_term_refresh_freeze);
SCRIPT_FUN(irssi_term_refresh_thaw);
#endif
